'use strict';

require('babel-register')({
  presets: [require.resolve('babel-preset-react'), require.resolve('babel-preset-es2015'), require.resolve('babel-preset-stage-0')],
  plugins: [require.resolve('babel-plugin-transform-flow-strip-types')]
});

var Mocha = require('mocha');
var Glob = require('glob');
var Chokidar = require('chokidar');
var config = require('../config.tmp.json');

function test() {
  Object.keys(require.cache).forEach(function (key) {
    return delete require.cache[key];
  });

  var pattern = config.appSrc + '/**/*.spec.js';
  var mocha = new Mocha();

  Glob(pattern, {}, function (err, files) {
    files.forEach(function (file) {
      return mocha.addFile(file);
    });
    mocha.run(function (failures) {
      process.on('exit', function () {
        process.exit(failures);
      });

      console.log('Watching for changes...');
    });
  });
}

function watch() {
  var watcher = Chokidar.watch(config.appSrc, {
    ignored: /[\/\\]\./,
    persistent: true
  });

  watcher.on('change', function () {
    return test();
  });
}

module.exports = function () {
  test();
  watch();
};