'use strict';

var webpack = require('webpack');
var path = require('path');
var HappyPack = require('happypack');
var Logger = require('../util/logger');

function getBabelQuery(config) {
  var plugins = [];
  var presets = [];

  if (config.schema) {
    presets.push({
      plugins: [require.resolve('../util/babelRelayPlugin')]
    });
  }

  presets.push(require.resolve('babel-preset-react'));
  presets.push(require.resolve('babel-preset-es2015'));

  presets.push(require.resolve('babel-preset-stage-0'));

  if (config.hotLoader) {
    plugins.push(require.resolve('react-hot-loader/babel'));
  }

  // plugins = plugins.concat([
  //   require("babel-plugin-transform-es2015-template-literals"),
  //   require("babel-plugin-transform-es2015-literals"),
  //   require("babel-plugin-transform-es2015-function-name"),
  //   require("babel-plugin-transform-es2015-arrow-functions"),
  //   require("babel-plugin-transform-es2015-block-scoped-functions"),
  //   require("babel-plugin-transform-es2015-classes"),
  //   require("babel-plugin-transform-es2015-object-super"),
  //   require("babel-plugin-transform-es2015-shorthand-properties"),
  //   require("babel-plugin-transform-es2015-duplicate-keys"),
  //   require("babel-plugin-transform-es2015-computed-properties"),
  //   require("babel-plugin-transform-es2015-for-of"),
  //   require("babel-plugin-transform-es2015-sticky-regex"),
  //   require("babel-plugin-transform-es2015-unicode-regex"),
  //   require("babel-plugin-check-es2015-constants"),
  //   require("babel-plugin-transform-es2015-spread"),
  //   require("babel-plugin-transform-es2015-parameters"),
  //   require("babel-plugin-transform-es2015-destructuring"),
  //   require("babel-plugin-transform-es2015-block-scoping"),
  //   require("babel-plugin-transform-es2015-typeof-symbol"),
  //   require("babel-plugin-transform-regenerator"),
  //   require("babel-plugin-transform-async-to-generator"),
  //   require("babel-plugin-transform-object-rest-spread"),
  //   require("babel-plugin-transform-class-properties"),
  // ]);

  plugins.push(require.resolve('babel-plugin-transform-remove-strict-mode'));
  plugins.push(require.resolve('babel-plugin-transform-flow-strip-types'));
  //plugins.push(require.resolve('babel-plugin-react-css-modules'));

  var query = {
    babelrc: false,
    passPerPreset: true,
    cacheDirectory: config.cache ? config.cache : false,
    presets: presets,
    plugins: plugins
  };

  return query;
}
/**
 *
 * @param {String} env
 *
 */
function getBabelLoader(config) {
  var cache = config.cache;

  var loaders = [];

  // if (config.cache) {
  //   loaders.push(require.resolve('happypack/loader'));
  // } else {
  loaders.push({
    loader: require.resolve('babel-loader'),
    options: getBabelQuery(config)
  });
  // }

  var loader = {
    test: /\.(js|jsx)$/,
    include: [config.appSrc, path.resolve(__dirname, '../reactHot')],
    use: loaders
  };

  return loader;
}

module.exports = {
  getBabelLoader: getBabelLoader,
  getBabelQuery: getBabelQuery
};