'use strict';

var webpack = require('webpack');
var path = require('path');
var config = require('../config.tmp.json');
var HappyPack = require('happypack');
var Logger = require('../util/logger');

// Loaders
var jsLoader = require('./jsLoader').getBabelLoader;

var _require = require('./styleLoader'),
    globalCssLoader = _require.globalCssLoader,
    globalSassLoader = _require.globalSassLoader,
    cssLoader = _require.cssLoader,
    sassLoader = _require.sassLoader;

var getPlugins = require('./plugins');

module.exports = {
  entry: [require.resolve('babel-polyfill'), require.resolve('whatwg-fetch'), config.entry],
  // resolveLoader: {
  //   root: path.join(__dirname, '/../node_modules'),
  //   moduleTemplates: ['*-loader'],
  // },
  module: {
    loaders: [jsLoader(config), globalCssLoader(config), globalSassLoader(config), sassLoader(config), {
      test: /\.(woff|woff2)(\?v=\d+\.\d+\.\d+)?$/,
      loader: require.resolve('url-loader') + '?limit=10000&mimetype=application/font-woff'
    }, {
      test: /\.ttf(\?v=\d+\.\d+\.\d+)?$/,
      loader: require.resolve('url-loader') + '?limit=10000&mimetype=application/octet-stream'
    }, {
      test: /\.(eot|svg)(\?v=\d+\.\d+\.\d+)?$/,
      loader: require.resolve('file-loader')
    }]
  },
  output: {
    path: config.staticsPath || config.path,
    filename: config.filename || 'bundle.js',
    publicPath: config.publicPath
  },
  plugins: getPlugins(config)
};